Package net.sf.saxon.style

## Class StylesheetFunctionLibrary

- java.lang.Object
- - net.sf.saxon.style.StylesheetFunctionLibrary

- All Implemented Interfaces:
    `FunctionLibrary`

      public class StylesheetFunctionLibrary
      extends java.lang.Object
      implements FunctionLibrary

  A StylesheetFunctionLibrary contains functions defined by the user in a stylesheet. This library is used at compile time only, as it contains references to the actual XSLFunction objects. Binding to a function in this library registers the function call on a fix-up list to be notified when the actual compiled function becomes available.

- - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `StylesheetFunctionLibrary​(StylesheetPackage sheet, boolean overrideExtensionFunction)` | Create a FunctionLibrary that provides access to stylesheet functions

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `Expression` | `bind​(SymbolicName.F functionName, Expression[] staticArgs, StaticContext env, java.util.List<java.lang.String> reasons)` | Bind a function, given the URI and local parts of the function name, and the list of expressions supplied as arguments.
    `FunctionLibrary` | `copy()` | This method creates a copy of a FunctionLibrary: if the original FunctionLibrary allows new functions to be added, then additions to this copy will not affect the original, or vice versa.
    `Function` | `getFunctionItem​(SymbolicName.F functionName, StaticContext staticContext)` | Test whether a function with a given name and arity is available; if so, return a function item that can be dynamically called.
    `StylesheetPackage` | `getStylesheetPackage()` | Get the stylesheet package to which this function library relates
    `boolean` | `isAvailable​(SymbolicName.F functionName)` | Test whether a function with a given name and arity is available
    `boolean` | `isOverrideExtensionFunction()` | Ask whether the functions in this library are "overrideExtensionFunction" functions, that is, defined with xsl:function override="yes".

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface net.sf.saxon.functions.FunctionLibrary

      `setConfiguration`

- - ### Constructor Detail

    - #### StylesheetFunctionLibrary

          public StylesheetFunctionLibrary​(StylesheetPackage sheet,
                                           boolean overrideExtensionFunction)

      Create a FunctionLibrary that provides access to stylesheet functions
      Parameters:
        `sheet` - The XSLT package
        `overrideExtensionFunction` - set to true if this library is to contain functions specifying override="yes", or to false if it is to contain functions specifying override="no". (XSLT uses two instances of this class, one for overrideExtensionFunction functions and one for non-overrideExtensionFunction functions.)

  - ### Method Detail

    - #### isOverrideExtensionFunction

          public boolean isOverrideExtensionFunction()

      Ask whether the functions in this library are "overrideExtensionFunction" functions, that is, defined with xsl:function override="yes".
      Returns:
        true if these are overrideExtensionFunction functions, false otherwise

    - #### getStylesheetPackage

          public StylesheetPackage getStylesheetPackage()

      Get the stylesheet package to which this function library relates
      Returns:
        the stylesheet package

    - #### bind

          public Expression bind​(SymbolicName.F functionName,
                                 Expression[] staticArgs,
                                 StaticContext env,
                                 java.util.List<java.lang.String> reasons)

      Bind a function, given the URI and local parts of the function name, and the list of expressions supplied as arguments. This method is called at compile time.
      Specified by:
        `bind` in interface `FunctionLibrary`
      Parameters:
        `functionName` - The name of the function
        `staticArgs` - The expressions supplied statically in the function call. The intention is that the static type of the arguments (obtainable via getItemType() and getCardinality() may be used as part of the binding algorithm.
        `env` - The static context
        `reasons` - In the event that a function cannot be bound, this output parameter may be populated with one or more diagnostic messages indicating possible reasons why no function binding was possible.
      Returns:
        An object representing the extension function to be called, if one is found; null if no extension function was found matching the required name and arity.

    - #### getFunctionItem

          public Function getFunctionItem​(SymbolicName.F functionName,
                                          StaticContext staticContext)
                                   throws XPathException

      Test whether a function with a given name and arity is available; if so, return a function item that can be dynamically called.

      This supports the function-lookup() function in XPath 3.0.

      Specified by:
        `getFunctionItem` in interface `FunctionLibrary`
      Parameters:
        `functionName` - the qualified name of the function being called
        `staticContext` - the static context to be used by the function, in the event that it is a system function with dependencies on the static context
      Returns:
        if a function of this name and arity is available for calling, then a corresponding function item; or null if the function does not exist
      Throws:
        `XPathException` - in the event of certain errors, for example attempting to get a function that is private

    - #### isAvailable

          public boolean isAvailable​(SymbolicName.F functionName)

      Test whether a function with a given name and arity is available

      This supports the function-available() function in XSLT.

      Specified by:
        `isAvailable` in interface `FunctionLibrary`
      Parameters:
        `functionName` - the qualified name of the function being called
      Returns:
        true if a function of this name and arity is available for calling

    - #### copy

          public FunctionLibrary copy()

      This method creates a copy of a FunctionLibrary: if the original FunctionLibrary allows new functions to be added, then additions to this copy will not affect the original, or vice versa.
      Specified by:
        `copy` in interface `FunctionLibrary`
      Returns:
        a copy of this function library. This must be an instance of the original class.